#ifndef MCON2_INCLUDED
#define MCON2_INCLUDED

#ifndef WINDOWS_H
#define WINDOWS_H
#include <windows.h>
#endif

class OCON
{ 
  public:
       OCON(const char *title);
       OCON(void);
       ~OCON();

       OCON& operator<<(const char* s);
       OCON& OCON::operator<<(const WCHAR *s);
       OCON& operator<<(const char ch);
       OCON& operator<<(const signed char ch);
       OCON& operator<<(const unsigned char ch);
       OCON& operator<<(const bool b);
       OCON& operator<<(const short int i);
       OCON& operator<<(const unsigned short int i);       
       OCON& operator<<(const int i);
       OCON& operator<<(const unsigned int i);
       OCON& operator<<(const signed long dd);
       OCON& operator<<(const unsigned long dd);
       OCON& operator<<(const float d);
       OCON& operator<<(const double &d);  
       OCON& operator<<(const void* p);
       OCON& operator<<(const signed __int64 &i);
       OCON& operator<<(const unsigned __int64 &i);
       
       void SetConsoleTextAttributeWord(WORD atr);
       void SetConsoleTextAttribute(BYTE color16 = 0x07);

  protected:
       void OUT_CON(void);
       void INIT(void);
       
       HANDLE hCON;
       char sCON[65536];       
};

#endif