// CMainDlg.h : header file
//

#if !defined(AFX_CMAINDLG_H__D816F8C6_FD3A_4467_9B0A_31997DF515EC__INCLUDED_)
#define AFX_CMAINDLG_H__D816F8C6_FD3A_4467_9B0A_31997DF515EC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog

#include "OSerialPort.h"
#include "OSerialPortEnum.h"


class CMainDlg : public CDialog
{
// Construction
public:
	BYTE OutByte(BYTE b);
	CMainDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMainDlg)
	enum { IDD = IDD_NIKYCOMPROGPIC16F873A_DIALOG };
	CRichEditCtrl	m_Edit1;
	CComboBox	m_Combo1;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//void WaitData(BYTE *Buf, int BufSz, int &ReadedSz, int TimeOut);
	
 void Prepare();
	BYTE GetByte(const char *Buf, int &Pos) const;
	void OpenHexFile(const char *Name);
	void OpenPort();
	HICON m_hIcon;

 //int m_PortSelect;
 OSerialPortSelector m_PortSelector;
 OSerialPort m_Port;

 struct TMKBuffer
 {
   BYTE Flash[65536*2];

   BYTE ExMemRegs[8][64]; //  . .  PicMemRegions[PicMemRegionsN]
 };

 TMKBuffer m_Buffer;
 TMKBuffer m_VerifyBuffer;

 void CMainDlg::JMDReadAllMKBuf(TMKBuffer & Buffer);
 void CMainDlg::CmdBuffersVerify();


	void CopyBufferToEdit(const TMKBuffer & Buffer);
 void CMainDlg::CopyBufferToEdit_HEX();
 void CMainDlg::CopyBufferToEdit_MK();

 bool CMainDlg::ReadVerifyBuffer();



 void CMainDlg::SetReset(BOOL IsHi);
 void CMainDlg::SetCLK(BOOL IsHi);
 void CMainDlg::SetData(BOOL IsHi);
 BOOL CMainDlg::GetDataIn();

 void CMainDlg::OutCmd8(BYTE Cmd);
 void CMainDlg::OutData24(DWORD Data);
 DWORD CMainDlg::InData24();

 void CMainDlg::Prog_Load_PC_Address(DWORD Adr);
 WORD CMainDlg::Prog_Read_Data_from_NVM(BOOL IsIncPC);
 void CMainDlg::Prog_Bulk_Erase_Program_Memory();
 void CMainDlg::Prog_Load_Data_for_NVM(WORD Data, BOOL IsIncPC);
 void CMainDlg::Prog_ProgInternally();
 void CMainDlg::Prog_IncPCAdr();














	// Generated message map functions
	//{{AFX_MSG(CMainDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnSelendokCombo1();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButtonSave();
	afx_msg void OnButtonTest();
	afx_msg void OnButtonStart();
	afx_msg void OnButtonUsercmd();
 afx_msg void OnButtonGenRnd();
	afx_msg void OnCheck1();
	afx_msg void OnDestroy();
 afx_msg LRESULT OnMy_WM_DEVICECHANGE(WPARAM wParam, LPARAM lParam);
	afx_msg void OnBUTTON9SetBreak();
	afx_msg void OnBUTTON10ClrBreak();
	afx_msg void OnBUTTON11SetRTS();
	afx_msg void OnBUTTON12ClrRTS();
	afx_msg void OnBUTTON13SetDTR();
	afx_msg void OnBUTTON14ClrDTR();
	afx_msg void OnBUTTON15StartJMDProg();
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
 CRichEditCtrl m_EditLinks;
 afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
 afx_msg void OnBnClickedButtonHelp3();
 afx_msg void OnLinkRichedit21(NMHDR *pNMHDR, LRESULT *pResult);
 afx_msg void OnBnClickedButton15Startjmdprog2();
 afx_msg void OnBnClickedButton15Startjmdprog3();
 afx_msg void OnBnClickedCheck8Rdonlycfg();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CMAINDLG_H__D816F8C6_FD3A_4467_9B0A_31997DF515EC__INCLUDED_)
