// NikyTimer1.cpp: implementation of the CNikyTimer1 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NikyTimer1.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNikyTimer1::CNikyTimer1()
{ 
  if (!QueryPerformanceFrequency((LARGE_INTEGER *)&m_FM)) 
    AfxMessageBox("QueryPerformanceFrequency  !");
  QueryPerformanceCounter((LARGE_INTEGER *)&m_T1);
};

CNikyTimer1::~CNikyTimer1()
{
};

void CNikyTimer1::Start()
{ 
  QueryPerformanceCounter((LARGE_INTEGER *)&m_T1);
};

double CNikyTimer1::GetTime()
{ 
  __int64 T2;
  QueryPerformanceCounter((LARGE_INTEGER *)&T2);
  return double(T2-m_T1)/m_FM;
};

double CNikyTimer1::GetTimeAndRestart()
{ 
  __int64 T2;
  QueryPerformanceCounter((LARGE_INTEGER *)&T2);
  __int64 dT = T2 - m_T1;
  m_T1 = T2;
  return double(dT)/m_FM;
};


__int64 CNikyTimer1::GetTimeRaw() const 
{ 
  __int64 T;
  QueryPerformanceCounter((LARGE_INTEGER *)&T);
  return T;
};